module SimpleCrop

using Persefone:
    FarmPlot,
    Length,
    m,
    SimulationModel

import Persefone:
    stepagent!,
    croptype,
    cropname,
    cropheight,
    cropcover,
    cropyield

struct CropType
    name::String
end

cropname(ct::CropType) = ct.name

mutable struct CropState
    croptype::CropType
    height::Length{Float64}
end

croptype(cs::CropState) = cs.croptype
cropname(cs::CropState) = cropname(croptype(cs))
cropheight(cs::CropState) = cs.height
cropcover(cs::CropState) = 0.0
cropyield(cs::CropState) = 0.0  # TODO: units?


"""
    stepagent!(farmplot, model)

Update a farm plot by one day.
"""
function stepagent!(farmplot::FarmPlot{CropState}, model::SimulationModel)
    # TODO: do something simple
end

end # module SimpleCrop
